#include <Adafruit_NeoPixel.h>
#include <DS3232MZ_RTC.h>
#include <IRremote.h>

#define PIN 5
#define NUMPIXELS 280
#define RGB 0
#define HSV 1

int IR_RECEIVE_PIN=4;
IRrecv IrReceiver(IR_RECEIVE_PIN);
int codeType=-1;
uint32_t codeValue;
uint16_t address;
uint8_t codeLen;

int mode=0;
bool up=0;
bool dn=0;
bool btnflg=0;
int colorflg=0; //red,orange,yellow,green,cyan,blue,magenta,pink,white,rainbow

//Dehumidifier remote: NEC
// 0x4FB40BF,BBF4F9F   0x4FB906F,DFE70A3
// 0x4FB58A7,D5A04AFF  0x4FB50AF,2427CC83
// 0x4FB9867,90E6EF1F  0x4FB8877,98934743

#define LED 2
#define LDR A3
#define B0  A0
#define B1  A1
#define B2  A2

char seconds=0;
char minutes=0;
char hours=0;
char weekday=0;
char date=0;
char month=0;
char year=0;

long color=0;
unsigned long brightness=0;

Adafruit_NeoPixel pixels(NUMPIXELS,PIN,NEO_GRB+NEO_KHZ800);

const char SmallFont[] PROGMEM = {  //5x7 Small 8 bit Font
                                0x00,0x00,0x00,0x00,0x00, // ' '  , 480 bytes
                                0x00,0x00,0x5F,0x00,0x00, // !
                                0x00,0x07,0x00,0x07,0x00, // "
                                0x14,0x7F,0x14,0x7F,0x14, // #
                                0x24,0x2A,0x7F,0x2A,0x12, // $
                                0x23,0x13,0x08,0x64,0x62, // %
                                0x36,0x49,0x55,0x22,0x50, // &
                                0x00,0x05,0x03,0x00,0x00, // '
                                0x00,0x1C,0x22,0x41,0x00, // (
                                0x00,0x41,0x22,0x1C,0x00, // )
                                0x14,0x08,0x3E,0x08,0x14, // *
                                0x08,0x08,0x3E,0x08,0x08, // +
                                0x00,0x50,0x30,0x00,0x00, // ,
                                0x08,0x08,0x08,0x08,0x08, // -
                                0x00,0x60,0x60,0x00,0x00, // .
                                0x40,0x20,0x10,0x08,0x04, // /
              
                                0x3E,0x51,0x49,0x45,0x3E, //0
                                0x00,0x42,0x7F,0x40,0x00, //1
                                0x42,0x61,0x51,0x49,0x46, //2
                                0x22,0x49,0x49,0x49,0x36, //3
                                0x18,0x14,0x12,0x7F,0x10, //4
                                0x27,0x45,0x45,0x45,0x39, //5*
                                0x3E,0x49,0x49,0x49,0x32, //6
                                0x01,0x01,0x71,0x09,0x07, //7
                                0x36,0x49,0x49,0x49,0x36, //8
                                0x26,0x49,0x49,0x49,0x3E, //9
                                0x00,0x36,0x36,0x00,0x00, // :
                                0x00,0x56,0x36,0x00,0x00, // ;
                                0x08,0x14,0x22,0x41,0x00, // <
                                0x14,0x14,0x14,0x14,0x14, // =
                                0x41,0x22,0x14,0x08,0x00, // >
                                0x02,0x01,0x51,0x09,0x06, // ?
             
                                0x32,0x49,0x79,0x41,0x3E, // @
                                0x7C,0x12,0x11,0x12,0x7C, //A*
                                0x7F,0x49,0x49,0x49,0x36, //B
                                0x3E,0x41,0x41,0x41,0x22, //C
                                0x7F,0x41,0x41,0x41,0x3E, //D
                                0x7F,0x49,0x49,0x49,0x41, //E
                                0x7F,0x09,0x09,0x09,0x01, //F
                                0x3E,0x41,0x49,0x49,0x7A, //G
                                0x7F,0x08,0x08,0x08,0x7F, //H
                                0x00,0x41,0x7F,0x41,0x00, //I
                                0x20,0x41,0x41,0x3F,0x01, //J
                                0x7F,0x08,0x14,0x22,0x41, //K
                                0x7F,0x40,0x40,0x40,0x40, //L
                                0x7F,0x02,0x0C,0x02,0x7F, //M
                                0x7F,0x04,0x08,0x10,0x7F, //N
                                0x3E,0x41,0x41,0x41,0x3E, //O
            
                                0x7F,0x09,0x09,0x09,0x06, //P
                                0x3E,0x41,0x51,0x21,0x5E, //Q
                                0x7F,0x09,0x19,0x29,0x46, //R
                                0x26,0x49,0x49,0x49,0x32, //S
                                0x01,0x01,0x7F,0x01,0x01, //T
                                0x3F,0x40,0x40,0x40,0x3F, //U
                                0x1F,0x20,0x40,0x20,0x1F, //V
                                0x3F,0x40,0x38,0x40,0x3F, //W
                                0x63,0x14,0x08,0x14,0x63, //X
                                0x07,0x08,0x70,0x08,0x07, //Y
                                0x61,0x51,0x49,0x45,0x43, //Z
                                0x00,0x7F,0x41,0x41,0x00, // [
                                0x15,0x16,0x7C,0x16,0x15, // Yen
                                0x00,0x41,0x41,0x7F,0x00, // ]
                                0x04,0x02,0x01,0x02,0x04, // ^
                                0x40,0x40,0x40,0x40,0x40, // _
            
                                0x00,0x01,0x02,0x04,0x00, // `
                                0x20,0x54,0x54,0x54,0x78, //a
                                0x7F,0x48,0x44,0x44,0x38, //b
                                0x38,0x44,0x44,0x44,0x20, //c
                                0x38,0x44,0x44,0x48,0x7F, //d
                                0x38,0x54,0x54,0x54,0x18, //e
                                0x08,0x7E,0x09,0x01,0x02, //f
                                0x0C,0x52,0x52,0x52,0x3E, //g
                                0x7F,0x08,0x04,0x04,0x78, //h
                                0x00,0x44,0x7D,0x40,0x00, //i
                                0x20,0x40,0x44,0x3D,0x00, //j
                                0x7F,0x10,0x28,0x44,0x00, //k
                                0x00,0x41,0x7F,0x40,0x00, //l
                                0x7C,0x04,0x18,0x04,0x78, //m
                                0x7C,0x08,0x04,0x04,0x78, //n
                                0x38,0x44,0x44,0x44,0x38, //o
           
                                0x7C,0x14,0x14,0x14,0x08, //p
                                0x08,0x14,0x14,0x18,0x7C, //q
                                0x7C,0x08,0x04,0x04,0x08, //r
                                0x48,0x54,0x54,0x54,0x24, //s
                                0x04,0x3F,0x44,0x40,0x20, //t
                                0x3C,0x40,0x40,0x20,0x7C, //u
                                0x1C,0x20,0x40,0x20,0x1C, //v
                                0x3C,0x40,0x38,0x40,0x3C, //w
                                0x44,0x28,0x10,0x28,0x44, //x
                                0x0C,0x50,0x50,0x50,0x3C, //y
                                0x44,0x64,0x54,0x4C,0x44, //z
                                0x00,0x08,0x36,0x41,0x00, // {
                                0x00,0x00,0x7F,0x00,0x00, // |
                                0x00,0x41,0x36,0x08,0x00, // }
                                0x08,0x08,0x2A,0x1C,0x08, // ->
                                0x08,0x1C,0x2A,0x08,0x08};// <-

void drawchar(char dig, char num, long R, char G, char B, bool mode){
  for(int i=0;i<5;i++){  //row
    for(int j=0;j<7;j++){  //column
      if( (pgm_read_byte_near(((SmallFont+i+5*(num-32))))>>j)&0b1 ){
          if(mode==RGB){
            pixels.setPixelColor(7*(i)+(j)+35*dig,R,G,B); //R,G,B
          }else{
            pixels.setPixelColor(7*(i)+(j)+35*dig,R);
          }
      }else{
        pixels.setPixelColor(7*(i)+(j)+35*dig,0,0,0);
      }
    }
  }
  //pixels.show();
}

void mainTime(){
  seconds=decodeTime(readI2C(RTCaddr,SECS));
  minutes=decodeTime(readI2C(RTCaddr,MINS));
  hours=decodeTime(readI2C(RTCaddr,HRS));
  
  int hrs=0;
  if(hours>12){hrs=hours-=12;}else{hrs=hours;}
  long t=100*seconds;
  long c=0;
  char v=255;
  switch(colorflg){
    case 0: //red
      c=0;v=255;
      break;
    case 1: //orange
      c=8000;v=255;
      break;
    case 2: //yellow
      c=16000;v=255;
      break;
    case 3: //green
      c=24000;v=255;
      break;
    case 4: //cyan
      c=32000;v=255;
      break;
    case 5: //blue
      c=40000;v=255;
      break;
    case 6: //magenta
      c=48000;v=255;
      break;
    case 7: //pink
      c=56000;v=255;
      break;
    default:  //white
      c=255;v=0;
  }

  if(colorflg!=9){
    drawchar(0,hrs/10+48,pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(1,hrs%10+48,pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(2,':',pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(3,minutes/10+48,pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(4,minutes%10+48,pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(5,':',pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(6,seconds/10+48,pixels.ColorHSV(c,v,brightness),0,0,HSV);
    drawchar(7,seconds%10+48,pixels.ColorHSV(c,v,brightness),0,0,HSV);
  }else{
    drawchar(0,hrs/10+48,pixels.ColorHSV(color+t,255,brightness),0,0,HSV);
    drawchar(1,hrs%10+48,pixels.ColorHSV(color+t+8000,255,brightness),0,0,HSV);
    drawchar(2,':',pixels.ColorHSV(color+t+16000,255,brightness),0,0,HSV);
    drawchar(3,minutes/10+48,pixels.ColorHSV(color+t+24000,255,brightness),0,0,HSV);
    drawchar(4,minutes%10+48,pixels.ColorHSV(color+t+32000,255,brightness),0,0,HSV);
    drawchar(5,':',pixels.ColorHSV(color+t+40000,255,brightness),0,0,HSV);
    drawchar(6,seconds/10+48,pixels.ColorHSV(color+t+48000,255,brightness),0,0,HSV);
    drawchar(7,seconds%10+48,pixels.ColorHSV(color+t+56000,255,brightness),0,0,HSV);
  }
  pixels.show();
}

void menu(int mode){
  int t1,t2=0;
  if(mode==1){t1=20000;t2=4000;}else{t1=4000;t2=20000;}
  if(up){
    if(t1==20000){
      if(hours<23){
        hours++;
      }else{hours=0;}
      writeI2C(RTCaddr,HRS,encodeTime(hours));
      Serial.println(hours,DEC);
    }else{
      if(minutes<59){
        minutes++;
      }else{minutes=0;}
      writeI2C(RTCaddr,MINS,encodeTime(minutes));
      Serial.println(minutes,DEC);
    }
    writeI2C(RTCaddr,SECS,encodeTime(0));
    up=0;  
  }
  if(dn){
    if(t1==20000){
      if(hours>0){
        hours--;
      }else{hours=23;}
      writeI2C(RTCaddr,HRS,encodeTime(hours));
      Serial.println(hours,DEC);
    }else{
      if(minutes>0){
        minutes--;
      }else{minutes=59;}
      writeI2C(RTCaddr,MINS,encodeTime(minutes));
      Serial.println(minutes,DEC);
    }
    writeI2C(RTCaddr,SECS,encodeTime(0));
    dn=0;
  }
  drawchar(0,'S',pixels.ColorHSV(0,255,brightness),0,0,HSV);
  drawchar(1,'e',pixels.ColorHSV(0,255,brightness),0,0,HSV);
  drawchar(2,'t',pixels.ColorHSV(0,255,brightness),0,0,HSV);
  drawchar(3,hours/10+48,pixels.ColorHSV(t1,255,brightness),0,0,HSV);
  drawchar(4,hours%10+48,pixels.ColorHSV(t1,255,brightness),0,0,HSV);
  drawchar(5,':',pixels.ColorHSV(4000,255,brightness),0,0,HSV);
  drawchar(6,minutes/10+48,pixels.ColorHSV(t2,255,brightness),0,0,HSV);
  drawchar(7,minutes%10+48,pixels.ColorHSV(t2,255,brightness),0,0,HSV);
  pixels.show();
}

void readLDR(void){ // Range ~183-960 mapped (light to dark) to 128-255 pwm
  brightness=analogRead(LDR);
  brightness=(-0.25*brightness+285); //-.163
  if(brightness>255){brightness=255;}
  if(brightness<64){brightness=64;} //128
  //brightness=brightness;
  Serial.println(brightness);
}

void setup() {
  pixels.begin();
  pixels.show();
  pixels.setBrightness(8);

  Serial.begin(115200);
  Serial.println("CLOCK");
  init_RTC();

  IrReceiver.enableIRIn();
  //IrReceiver.blink13(true); //LED is on D2, cant use this without modification
  
  int cnt=33;
  colorflg=readI2C(RTCaddr,SRAM);

  pinMode(0,OUTPUT);
  digitalWrite(0,LOW);
  pinMode(1,INPUT_PULLUP);
  pinMode(LED,OUTPUT);
  pinMode(B0,INPUT_PULLUP);
  pinMode(B1,INPUT_PULLUP);
  pinMode(B2,INPUT_PULLUP);
}

void loop() {
  readLDR();
  
  if(!digitalRead(B0)){dn=1;}
  if(!digitalRead(B1)){if(mode<2){mode++;}else{mode=0;}}
  if(!digitalRead(B2)){up=1;}
  
  if(IrReceiver.decode()){
    digitalWrite(LED,HIGH);
    codeType=IrReceiver.results.decode_type;
    address=IrReceiver.results.address;
    codeValue=IrReceiver.results.value;
    codeLen=IrReceiver.results.bits;
    IrReceiver.resume();
    //Serial.println(codeType);
    //Serial.println(address,HEX);
    Serial.println(codeValue,HEX);
    //Serial.println(codeLen);
    if(codeValue==0x4FB40BF||codeValue==0xBBF4F9F){
      if(mode<2){mode++;}else{mode=0;}
      Serial.println(mode);
    }
    if(codeValue==0x4FB50AF||codeValue==0x2427CC83){
      up=1;
    }
    if(codeValue==0x4FB8877||codeValue==0x98934743){
      dn=1;
    }
    digitalWrite(LED,LOW);
  }

  if(mode!=0){
    menu(mode);
  }else{
    if(up==1){if(colorflg<9){colorflg++;}else{colorflg=0;}up=0;writeI2C(RTCaddr,SRAM,colorflg);}
    if(dn==1){if(colorflg>0){colorflg--;}else{colorflg=9;}dn=0;writeI2C(RTCaddr,SRAM,colorflg);}
    mainTime();
  }
  delay(200);
}
